#define PLUGIN "HUD and SNDs events"
#define VERSION "1.0"
#define AUTHOR "HoRRoR (and some code from unknown author)"

#include <amxmodx>
#include <engine>
#include <csx>
#include <fun>
#include <cstrike>

new g_c4timer, pointnum;
new bool:b_planted = false;
new bool:g_key;
new bool:is_started;
new timestr[6]
new Float:bmb_Ypos = 0.75
new Float:str_Ypos = 0.25

new bool:relay_RageQuit;
new bool:can_be_denied[33];

#define PRICE_RAGEQUIT 	700 	// $
#define PRICE_GENOCIDE	2000	// $
#define PRICE_BLOODBATH	1000	// $
#define PRICE_SMACKDOWN	2	// frags
#define RAGEQUIT_TIME	15.0
#define BLOODBATH_ID	10008
#define DENY_HP		10
#define MINPLAYERS	8

new streakSnd[][] = 
{
/*0*/	"misc/streaksounds/bloodbath.wav",
/*1*/	"misc/streaksounds/denied.wav",
/*2*/	"misc/streaksounds/genocide.wav",
/*3*/	"misc/streaksounds/ragequit.wav",
/*4*/	"misc/streaksounds/smackdown.wav"
}

public plugin_precache()
{
 	for (new i = 0; i < 5; i++)
		precache_sound(streakSnd[i])
}

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
 	pointnum = get_cvar_pointer("mp_c4timer");
	
	register_clcmd("say a", "gr")
	register_clcmd("say v", "gv")
	
	register_logevent("newRound", 2, "1=Round_Start");
	register_logevent("endRound", 2, "1=Round_End");
	register_logevent("endRound", 2, "1&Restart_Round_");
	
	register_event("DeathMsg", "event_player_death", "a")
	
	register_cvar("mp_timetorestart","30.0",FCVAR_SERVER) 
}

public gr(id)
	give_item(id, "weapon_hegrenade")

public gv(id)
	for (new i = 1; i <= 32; i++)
		if (is_user_alive(i) && is_user_bot(i))
			set_user_health(i,1)
	
public event_player_death()
{
	new killer = read_data(1)
	new victim = read_data(2)
	new weapon = read_data(4)
	
	new kName[24];
	if(relay_RageQuit && cs_is_not_one_team(killer, victim) && get_playersnum() >= MINPLAYERS)
	{
		get_user_name(killer, kName, 23);
		set_hudmessage(200, 20, 20, -1.0, str_Ypos, 0, 0.0, 4.0, 0.0, 2.0, -1);
		show_hudmessage(0, "%s is on RAGE QUIT!", kName);
		client_cmd(0, "spk %s", streakSnd[3])
		cs_add_user_money(killer, PRICE_RAGEQUIT)
		relay_RageQuit = false;
		remove_task(999)
	}
	
	if (get_user_health(killer) == 1 && get_user_armor(killer) == 0 && !relay_RageQuit  && cs_is_not_one_team(killer, victim))
	{
		get_user_name(killer, kName, 23);
		set_hudmessage(200, 20, 20, -1.0, str_Ypos, 0, 0.0, 4.0, 0.0, 2.0, -1);
		show_hudmessage(0, "%s is on SMACK DOWN!", kName);
		client_cmd(0, "spk %s", streakSnd[4])
		set_user_frags(killer, get_user_frags(killer) + PRICE_SMACKDOWN)
	}
	
	if (!relay_RageQuit && weapon == CSW_HEGRENADE  && cs_is_not_one_team(killer, victim))
	{
		static killTime[33], killCount[33] 
		static curTime 
		curTime = get_systime() 
		if (weapon == CSW_HEGRENADE  && cs_is_not_one_team(killer, victim))  
		{ 
			if (curTime == killTime[killer]) 
			{ 
				killCount[killer]++ 
				if (killCount[killer] == 3) 
				{ 
					get_user_name(killer, kName, 23);
					set_hudmessage(200, 20, 20, -1.0, str_Ypos, 0, 0.0, 4.0, 0.0, 2.0, -1);
					show_hudmessage(0, "%s is on BLOOD BATH!", kName);
					client_cmd(0, "spk %s", streakSnd[0])
					cs_add_user_money(killer, PRICE_BLOODBATH)
				} 
      
			} 
			else 
			{ 
				killTime[killer] = curTime 
				killCount[killer] = 0 
			} 
		}
	}
	
	if (!relay_RageQuit && !cs_is_not_one_team(killer, victim) && can_be_denied[victim] && killer != victim)
	{
		// get_user_health(victim) <= DENY_HP && damage > get_user_health(victim)
		new vName[24];
		get_user_name(killer, kName, 23);
		get_user_name(victim, vName, 23);
		set_hudmessage(200, 20, 20, -1.0, str_Ypos, 0, 0.0, 4.0, 0.0, 2.0, -1);
		show_hudmessage(0, "%s denied by %s", vName, kName);
		client_cmd(0, "spk %s", streakSnd[1])
		cs_set_user_deaths(victim, cs_get_user_deaths(victim) + 1)
		can_be_denied[victim] = false;
	}
}

public client_damage(attacker, victim)
	if (get_user_health(victim) <= DENY_HP)
		can_be_denied[victim] = true;


stock bool:cs_is_not_one_team(id1, id2)
{
	// fix for fall or trigger hurt kill
	if (id1 <= 32 && id2 <= 32 && id1 > 0 && id2 > 0 && is_valid_ent(id1) && is_valid_ent(id2))
		if(cs_get_user_team(id1) != cs_get_user_team(id2))
			return true;
	
	return false;
}

public switch_off_ragequit()
	relay_RageQuit = false;
	
public cs_add_user_money(id, ammount)
{
	new iMoney = cs_get_user_money(id)
	
	if (iMoney + ammount <= 16000)
		cs_set_user_money(id, iMoney + ammount)
	else	
		cs_set_user_money(id, 16000)
}
	
public event_check_genocide()
{
	if (get_playersnum() < MINPLAYERS)
		return PLUGIN_CONTINUE;
		
	new bool:is_CT_have_dead
	new bool:is_T_have_dead
	new bool:is_CT_have_alive
	new bool:is_T_have_alive
	
	for (new i = 1; i <= 32; i++)
	{
		if (is_valid_ent(i))
		{
			if (cs_get_user_team(i) == CS_TEAM_T)
			{
				if (!is_user_alive(i))
					is_T_have_dead = true
				else	
					is_T_have_alive = true
			}
			else if (cs_get_user_team(i) == CS_TEAM_CT)
			{
				if (!is_user_alive(i))
					is_CT_have_dead = true
				else	
					is_CT_have_alive = true
			}
		}
	}
	
	if (is_T_have_dead && !is_CT_have_dead && !is_T_have_alive && is_CT_have_alive)
	{
		set_hudmessage(200, 20, 20, -1.0, str_Ypos, 0, 0.0, 4.0, 0.0, 2.0, -1);
		show_hudmessage(0, "Terrorists team is completely wiped out!");
		client_cmd(0, "spk %s", streakSnd[2])
		
		for (new n = 1; n <= 32; n++)
			if (is_valid_ent(n) && cs_get_user_team(n) == CS_TEAM_CT)
				cs_add_user_money(n, PRICE_GENOCIDE)
		
	}else if (!is_T_have_dead && is_CT_have_dead && is_T_have_alive && !is_CT_have_alive)
	{
		set_hudmessage(200, 20, 20, -1.0, str_Ypos, 0, 0.0, 4.0, 0.0, 2.0, -1);
		show_hudmessage(0, "Counter-Terrorists team is completely wiped out!");
		client_cmd(0, "spk %s", streakSnd[2])
		
		for (new n = 1; n <= 32; n++)
			if (is_valid_ent(n) && cs_get_user_team(n) == CS_TEAM_T)
				cs_add_user_money(n, PRICE_GENOCIDE)
	}
	
	return PLUGIN_CONTINUE;
}

public newRound()
{
	remove_task(999)

	for (new i = 1; i <= 32; i++)
		can_be_denied[i] = false;
		
	if (!g_key)
	{
		g_key = true;
		
		set_task(get_cvar_float("mp_timetorestart"), "restartGame");
	}
	
	set_task(1.0, "showTime");
	g_c4timer = -1;
	remove_task(10003);
	b_planted = false;
	
	relay_RageQuit = true;
	set_task(RAGEQUIT_TIME, "switch_off_ragequit", 999)
}

public restartGame()
{
	server_cmd("sv_restart 1");
	is_started = true;
}

public showTime()
{
	new buffer[64]
	get_time("%H:%M", timestr, 5)
	new a = get_timeleft()
	
	if (is_started)
	{
		format(buffer, 63, "^x01Time (^x04%s^x01):(^x04%d^x01 mins left)", timestr, (a / 60));
	}else{
		format(buffer, 63, "^x01Time (^x04%s^x01):(Game is not started)", timestr);
	}
	
	for (new i = 1; i <=32; i++)
	{
		if (is_valid_ent(i))
		{
			message_begin(MSG_ONE, get_user_msgid("SayText"), _, i)
			write_byte(i)
			write_string(buffer)
			message_end()
		}
	}
}

public endRound()
{
	event_check_genocide();
	
	g_c4timer = -1;
	remove_task(10003);
}
 
public bomb_planted()
{
	b_planted = true;
	g_c4timer = get_pcvar_num(pointnum);
	dispTime()
	set_task(1.0, "dispTime", 10003, "", 0, "b");
}
 
public bomb_defused()
	if(b_planted)
	{
		remove_task(10003);
		b_planted = false;
	}
   
 
public bomb_explode()
	if(b_planted)
	{
		remove_task(10003);
		b_planted = false;
	}
	
 
public dispTime()
{   
	if(!b_planted)
	{
		remove_task(10003);
		return;
	}
        
 
	if(g_c4timer >= 0)
	{
		
		if(g_c4timer >= 20) 
			set_hudmessage(0, 150, 0, -1.0, bmb_Ypos, 0, 1.0, 1.1, 0.0, 0.0, -1)
		else if(g_c4timer >= 10) 
			set_hudmessage(150, 150, 0, -1.0, bmb_Ypos, 0, 1.0, 1.1, 0.0, 0.0, -1)
		else 
			set_hudmessage(150, 0, 0, -1.0, bmb_Ypos, 0, 1.0, 1.1, 0.0, 0.0, -1)
		
		if (g_c4timer >= 10)
			show_hudmessage(0, "-<  %d  >-", g_c4timer);
		else if (g_c4timer < 10 && g_c4timer != 0)
			show_hudmessage(0, "-<  0%d  >-", g_c4timer);
		else	
			show_hudmessage(0, "-< BOOM >-");
			
		--g_c4timer;
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
